#!/bin/bash
 ******** 使用的是 CSIG_Mac_Translator_Edu 打包

echo "Flutter iOS Build start ..."

result_branch=$(echo $Build_Branch | sed 's/\//_/')

# 新架构 proto 和 库的更新
cd ./package/data_model
./build.sh
cd - >/dev/null

# 统计上报埋点开关
echo "是否clickable dev "$isClickableDev
if [[ $isClickableDev == true ]]
then
  . ai_teacher_middle_school/clickable_dev.sh true  0.0.11
#else
#  . clickable_dev.sh false  0.0.11
fi


cd ./ai_teacher_middle_school

#ios打包的引擎使用，Android指定了本地的引擎路径
#### export PATH=/Users/apps/$FlutterVersionIos/bin:$PATH
#dart 路径生成proto文件使用
#### export PATH=/Users/apps/$FlutterVersionIos/bin/cache/dart-sdk/bin:$PATH
flutter --version


# 根据Target切换环境
# test: buildTarget=DailyBuild .Ω/build.sh
echo "工作目录:"$(pwd)

# 生成版本号
appVersion=$MajorVersion"."$MinorVersion"."$FixVersion
echo "App Version: "$appVersion

appBuildNumber=$BuildNo
echo "App Build Number: "$appBuildNumber


# 本地打包的测试代码
if [[ $appBuildNumber == "" ]]; then
    echo "local build";
    buildTarget=DailyBuild
    appBuildNumber=0
    appVersion='0.0.0'
    buildEnv=test
fi

echo "后台环境:"$buildEnv
#修改构建环境 dart 文件
./build_enviroment.sh $buildEnv $(pwd)/lib/enviroment_config.dart

echo "是否允许摇一摇调试:"$isEnableShakePopup
if [[ $isEnableShakePopup == true ]]; then
    modifyFile=lib/environment.dart
    sed -i ''  "s/_isEnableShakePopup = .*;/_isEnableShakePopup = true;/g"  $modifyFile
elif [[ $isEnableShakePopup == false ]]; then
    modifyFile=lib/environment.dart
    sed -i ''  "s/_isEnableShakePopup = .*;/_isEnableShakePopup = false;/g"  $modifyFile
fi

echo "prepare end.........."



# 解除 Flutter 构建锁
lockFile="/data/rdm/apps/flutter/bin/cache/lockfile"
if [[ -a "$lockFile" ]]; then
    echo "存在lockfile文件";
    rm -f "$lockFile"
fi


if ! [ $WORKSPACE ];then
    export WORKSPACE=.
fi

# 修改版本号
/usr/libexec/PlistBuddy -c "Set :CFBundleVersion $appBuildNumber" ios/Runner/Info.plist
/usr/libexec/PlistBuddy -c "Set :CFBundleShortVersionString $appVersion" ios/Runner/Info.plist

# 是否开启日志log导出的功能 提交AppStore时要关闭，否则会被拒
if [[ $iTunesFileSharing ]]
then
    if [[ $iTunesFileSharing == true ]]
    then
        /usr/libexec/PlistBuddy -c "Set :UIFileSharingEnabled true" ios/Runner/Info.plist
    elif [[ $iTunesFileSharing == false ]]
    then
        /usr/libexec/PlistBuddy -c "Set :UIFileSharingEnabled false" ios/Runner/Info.plist
    fi
fi

echo "#################  start flutter build  #####################"

flutter clean

# 开始构建

flutter build windows -v  --release  --target=$(pwd)/lib/main.dart
echo "command line: build ios -v   --build-name=$appVersion --build-number=$appBuildNumber   --release  --target=$(pwd)/lib/main.dart "


echo "构建完成"